@echo off

if not "%AS_ENV%"=="1" (
	call "%~dp0set-http-port"
	set AS_ENV=1
)


:execute-process

set LOGFILE=%~dp0log\%1.log
set AS_LOGFILE=%LOGFILE%

if exist "%LOGFILE%" (
	del "%LOGFILE%"
)

call :%*
set ERR=%ERRORLEVEL%

if %ERR%==0 (
	call :log R}h%1ɏI܂B
) else (
	call :log R}h%1ُI܂B
)
if exist "%~dp0pause.txt" pause
exit /B %ERR%
rem 
rem 
rem 
rem Tu[`Fcreate-server
rem 
:create-server
call :start-domain
if "%MULTI_SERVER%"=="1" (
	call :init-script-file %0
	call :log T[o[%SIT_AP_SERVER%쐬܂B
	echo create-local-instance %SIT_AP_SERVER% > "!SCRIPT_FILE!"
	call :execute "!SCRIPT_FILE!"
)
exit /B %ERRORLEVEL%
rem 
rem 
rem 
rem Tu[`Fsetup-as
rem 
:setup-as
call :restart-domain
call :restart-server
call :init-http-port

rem JDBChCojart@CAS̃NXpXʂtH_ɃRs[
if exist "%AS_JDBC_LIB%\%JDBC_JAR% " (
	call :log JDBChCo%JDBC_JAR%%AS_JDBC_LIB%ɃCXg[ςłB
) else (
	call :log JDBChCo%JDBC_JAR%CXg[܂B
	copy /Y lib\%JDBC_JAR% %AS_JDBC_LIB%
	call :restart-domain
)

call :init-script-file %0
call :log hC%DOMAIN%̃AvP[Vp\ݒ肵܂B

rem XNvgt@C̍쐬
echo create-jdbc-connection-pool ^
  --datasourceclassname %DATA_SRC_TYPE% ^
  --restype javax.sql.ConnectionPoolDataSource ^
  --property user=%APP_USER%:password=%APP_USER_PASS%:portNumber=%DB_PORT%:serverName=%DB_HOST%:databaseName=%DB%:characterEncoding=utf8 ^
  %CON_POOL% > "%SCRIPT_FILE%"
echo list-jdbc-connection-pools >> "%SCRIPT_FILE%"
echo ping-connection-pool %CON_POOL% >> "%SCRIPT_FILE%" 
echo create-jdbc-resource --target %SIT_AP_SERVER% --connectionpoolid %CON_POOL% %JDBC_RES% >> "%SCRIPT_FILE%" 
echo list-jdbc-resources >> "%SCRIPT_FILE%"
echo create-auth-realm --classname com.sun.enterprise.security.auth.realm.jdbc.JDBCRealm ^
  --target %SIT_AP_SERVER% ^
  --property datasource-jndi=%JDBC_RES%:user-table=m_user:user-name-column=user_id:password-column=password:group-table=m_user_group:group-name-column=group_id:jaas-context=jdbcRealm:digest-algorithm=SHA-256:encoding=Hex %REALM% >> "%SCRIPT_FILE%"

rem XNvgt@C̎s
call :execute "%SCRIPT_FILE%"

exit /B %ERRORLEVEL%
rem 
rem 
rem 
rem Tu[`Fstart-domain
rem 
:start-domain
call :check-domain
if "%DOMAIN_RUNNING%"=="0" (
	call :init-script-file %0
	call :log hCǗT[o[%DOMAIN%N܂B
	echo start-domain %DOMAIN% > "!SCRIPT_FILE!"
	call :execute "!SCRIPT_FILE!"
)
exit /B %ERRORLEVEL%
rem 
rem 
rem 
rem Tu[`Fstop-domain
rem 
:stop-domain
call :init-script-file %0
call :log hCǗT[o[%DOMAIN%~܂B
echo stop-domain %DOMAIN% > "%SCRIPT_FILE%"
call :execute "%SCRIPT_FILE%"
exit /B %ERRORLEVEL%
rem 
rem 
rem 
rem Tu[`Frestart-domain
rem 
:restart-domain
call :init-script-file %0
call :log hCǗT[o[%DOMAIN%ċN܂B
echo restart-domain %DOMAIN% > "%SCRIPT_FILE%"
call :execute "%SCRIPT_FILE%"
exit /B %ERRORLEVEL%
rem 
rem 
rem 
rem Tu[`Fstart-server
rem 
:start-server
call :start-domain
if "%MULTI_SERVER%"=="1" (
	call :check-server
	if "!SERVER_RUNNING!"=="0" (
		call :init-script-file %0
		call :log T[o[%SIT_AP_SERVER%N܂B
		echo start-local-instance %SIT_AP_SERVER% > "!SCRIPT_FILE!"
		call :execute "!SCRIPT_FILE!"
	)
)
exit /B %ERRORLEVEL%
rem 
rem 
rem 
rem Tu[`Fstop-server
rem 
:stop-server
if "%MULTI_SERVER%"=="1" (
	call :check-server
	if "!SERVER_RUNNING!"=="1" (
		call :init-script-file %0
		call :log T[o[%SIT_AP_SERVER%~܂B
		echo stop-local-instance %SIT_AP_SERVER% > "!SCRIPT_FILE!"
		call :execute "!SCRIPT_FILE!"
	)
)
exit /B %ERRORLEVEL%
rem 
rem 
rem 
rem Tu[`Frestart-server
rem 
:restart-server
if "%MULTI_SERVER%"=="1" (
	call :init-script-file %0
	call :log T[o[%SIT_AP_SERVER%ċN܂B
	echo restart-local-instance %SIT_AP_SERVER% > "!SCRIPT_FILE!"
	call :execute "!SCRIPT_FILE!"
)
exit /B %ERRORLEVEL%
rem 
rem 
rem 
rem Tu[`Fdeploy
rem 
:deploy
call :start-server
call :find-warfile
if ERRORLEVEL 1 (
	exit /B 1
) else (
	call :init-script-file %0
	call :log WARt@C%SIT_AP_SERVER%ɃfvC܂B
	call :echo-full-path %TARGET% %WAR_FILE%
	echo deploy --target %SIT_AP_SERVER% --name %WAR_FILE% --force '../../../%WEB_PRJ%/target/%WAR_FILE%' > "!SCRIPT_FILE!"
	call :execute "!SCRIPT_FILE!"
	exit /B !ERRORLEVEL!
)
rem 
rem 
rem 
rem Tu[`Fundeploy
rem 
:undeploy
call :start-server
call :find-warfile
call :init-script-file %0
if "%WAR_FILE%"=="" (
	echo list-applications > "!SCRIPT_FILE!"
) else (
	call :log %SIT_AP_SERVER%WARt@C̃fvC܂B
	call :echo-full-path %TARGET% %WAR_FILE%
	echo undeploy --target %SIT_AP_SERVER% %WAR_FILE% > "!SCRIPT_FILE!"
)
call :execute "%SCRIPT_FILE%"
exit /B %ERRORLEVEL%
rem 
rem 
rem 
rem Tu[`Fundeploy
rem 
:delete-server
call :start-domain
call :stop-server
call :init-script-file %0
call :log T[o[%SIT_AP_SERVER%폜܂B
rem echo delete-local-instance %SIT_AP_SERVER% > "%SCRIPT_FILE%"
echo delete-instance %SIT_AP_SERVER% > "%SCRIPT_FILE%"
call :execute "%SCRIPT_FILE%"
exit /B
rem 
rem 
rem 
rem Tu[`Fteardown-as
rem 
:teardown-as
call :start-server
call :init-script-file %0
call :log hC%DOMAIN%̃AvP[Vp\j܂B

echo delete-auth-realm --target %SIT_AP_SERVER% %REALM% > "%SCRIPT_FILE%"
echo delete-jdbc-resource --target %SIT_AP_SERVER% %JDBC_RES% >> "%SCRIPT_FILE%"
echo list-jdbc-resources  >> "%SCRIPT_FILE%"
echo delete-jdbc-connection-pool %CON_POOL% >> "%SCRIPT_FILE%"
echo list-jdbc-connection-pools>> "%SCRIPT_FILE%"
call :execute "%SCRIPT_FILE%"
exit /B %ERRORLEVEL%
rem 
rem 
rem 
rem Tu[`Finit-script-file
rem 
:init-script-file
set SCRIPT_FILE=%1.txt
set SCRIPT_FILE=script\%SCRIPT_FILE::=%
exit /B %ERRORLEVEL%
rem 
rem 
rem 
rem Tu[`Fexecute
rem 
:execute
call :log XNvgs܂B
call :log %~f1
call asadmin multimode --file "%~f1"
exit /B %ERRORLEVEL%
rem 
rem 
rem 
rem Tu[`Fcheck-domain
rem 
:check-domain
call :log hCǗT[o[%DOMAIN%ғĂ邩mF܂B
call asadmin list-domains > list-domains.txt
if ERRORLEVEL 1 exit /B %ERRORLEVEL%
for /F "usebackq" %%i in (`find "%DOMAIN%ғĂ܂" list-domains.txt`) do @set LINE=%%i
if "%LINE%"=="----------" (
	for /F "usebackq" %%i in (`find "%DOMAIN% running" list-domains.txt`) do @set LINE=%%i
)
if "%LINE%"=="----------" (
 	call :log hCǗT[o[%DOMAIN%͉ғĂ܂B
	set DOMAIN_RUNNING=0
) else (
	call :log hCǗT[o[%DOMAIN%͉ғĂ܂B
	set DOMAIN_RUNNING=1
)
del list-domains.txt
exit /B 0
rem 
rem 
rem 
rem Tu[`Fcheck-server
rem 
:check-server
call :log T[o[%SIT_AP_SERVER%ғĂ邩mF܂B
call asadmin list-instances > list-servers1.txt
if ERRORLEVEL 1 exit /B %ERRORLEVEL%
for /F "delims=" %%i in (list-servers1.txt) do (
	set servers=%%i
	echo !servers: =! >> list-servers2.txt
)
for /F "usebackq" %%i in (`find "%SIT_AP_SERVER%ғĂ܂" list-servers2.txt`) do @set LINE=%%i
if "%LINE%"=="----------" (
	for /F "usebackq" %%i in (`find "%SIT_AP_SERVER%notrunning" list-servers2.txt`) do @set LINE=%%i
)
if "%LINE%"=="----------" (
	call :log T[o[%SIT_AP_SERVER%͉ғĂ܂B
	set SERVER_RUNNING=1
) else (
 	call :log T[o[%SIT_AP_SERVER%͉ғĂ܂B
	set SERVER_RUNNING=0
)
del list-servers1.txt
del list-servers2.txt
exit /B 0
rem 
rem 
rem 
rem Tu[`Finit-port
rem 
:init-http-port
call :log %SIT_AP_SERVER%HTTP|[gmF܂B
if "%SIT_AP_SERVER%"=="server" (
	set PROP_KEY=configs.config.server-config.network-config.network-listeners.network-listener.http-listener-1.port
) else (
	set PROP_KEY=configs.config.%SIT_AP_SERVER%-config.system-property.HTTP_LISTENER_PORT.value
)
call asadmin get %PROP_KEY% > http-port.txt
if ERRORLEVEL 1 exit /B %ERRORLEVEL%
for /F "usebackq" %%i in (`find "%PROP_KEY%" http-port.txt`) do @set PORT=%%i
for /F "tokens=2 delims==" %%i in ("%PORT%") do @set PORT=%%i
call :log %SIT_AP_SERVER%HTTP|[g%PORT%łB
echo  set HTTP_PORT=%PORT%> set-http-port.cmd
del http-port.txt
exit /B %ERRORLEVEL%
rem 
rem 
rem 
rem Tu[`Ffind-warfile
rem 
:find-warfile
for /F "usebackq" %%i in (`dir /B /ON ..\..\..\*-web`) do @set WEB_PRJ=%%i

set TARGET=..\..\..\%WEB_PRJ%\target

for /F "usebackq" %%i in (`dir /B /ON "%TARGET%\*.war"`) do @set WAR_FILE=%%i

if "%WAR_FILE%"=="" (
	call :log ̃tH_ȉWARt@C܂B
	call :echo-full-path %TARGET%
	exit /B 1
)
exit /B 0
rem 
rem 
rem 
rem Tu[`Fecho-full-path
rem 
:echo-full-path
echo 	%~f1\%2
exit /B %ERRORLEVEL%

:log
echo ++ %1
exit /B
